﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Net.Http;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Threading.Tasks;
using Newtonsoft.Json;
using Xamarin.Forms;

namespace CircularGaugeGettingStarted
{

	public class RootObject
	{
		public List<Feed> Feeds { get; set; }
	}

	public class Feed : INotifyPropertyChanged

	{
		private double? _field1 = 0;
		[DefaultValue(0)]
		public double? Field1

		{
			get
			{
				return _field1.Value;
			}
			set
			{
				if (_field1.Value != value)
				{
					if (value == null)
						_field1 = 0;

					else
						_field1 = value;
					OnPropertyChanged();
				}
			}
		}
		public DateTime Created_at { get; set; }
		public int Entry_id { get; set; }


		int min = 0;


		public int Min
		{
			get { return min; }
			set
			{
				min = value;
				OnPropertyChanged("Min");
			}
		}

		int max = 50;


		public int Max
		{
			get { return max; }
			set
			{
				max = value;
				OnPropertyChanged("Max");
			}
		}


		private string _header;
		public string Header
		{
			get { return _header; }
			set
			{
				_header = value;
				OnPropertyChanged("Header");
			}
		}



		public event PropertyChangedEventHandler PropertyChanged;

		private void OnPropertyChanged([CallerMemberName] string propertyField1 = null)
		{
			{
				var handler = PropertyChanged;
				if (handler != null)
				{
					PropertyChangedEventArgs propertyChangedEvent
					= new PropertyChangedEventArgs(propertyField1);
					handler(this, propertyChangedEvent);
				}

			}
		}
	}



	public partial class CircularGaugeGettingStartedPage : ContentPage
	{
		private const string Url = "https://thingspeak.com/channels/301726/field/1.json";
		private HttpClient _client = new HttpClient();
		private ObservableCollection<Feed> _data;
		Feed model;
		string content;
		public CircularGaugeGettingStartedPage()
		{
			model = new Feed();
			this.BindingContext = model;
			InitializeComponent();
			Device.StartTimer(new TimeSpan(0, 0, 0, 0, 1000), TimerElapsed);
		}
		Random rn = new Random();
		private bool TimerElapsed()
		{
			Device.BeginInvokeOnMainThread(() =>
			{
				if (_data != null)
				{
					var val = rn.Next(0, _data.Count);

					model.Field1 = _data[val].Field1;
					model.Header = _data[val].Entry_id.ToString();
				}
			});
			return true;
		}

		protected override async void OnAppearing()
		{
			content = await _client.GetStringAsync(Url);
			RootObject data = JsonConvert.DeserializeObject<RootObject>(content);
			_data = new ObservableCollection<Feed>(data.Feeds);
			model.Min = (int)_data.Min(x => x.Field1);
			model.Max = (int)_data.Max(x => x.Field1);
			base.OnAppearing();
		}
		void OnAdd(object sender, System.EventArgs e)
		{
		}

		void OnUpdate(object sender, System.EventArgs e)
		{
		}

		void OnDelete(object sender, System.EventArgs e)
		{

		}
	}
}
